aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
diff options
context:
space:
mode:
authorGabor Juhos <juhosg@openwrt.org>2013-02-21 19:20:34 +0000
committerGabor Juhos <juhosg@openwrt.org>2013-02-21 19:20:34 +0000
commit17eba854404e31e92020821d5305b09b3c03c93b (patch)
tree746d92294129de0d98150a5fb66871d0bb7f65bd /target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
parent70d3a2f6404e2cda9fe05d654dd81b7101c75de6 (diff)
downloadmaster-187ad058-17eba854404e31e92020821d5305b09b3c03c93b.tar.gz
master-187ad058-17eba854404e31e92020821d5305b09b3c03c93b.tar.bz2
master-187ad058-17eba854404e31e92020821d5305b09b3c03c93b.zip
mpc85xx: add user-space support for the TL-WDR4900 v1
Signed-off-by: Gabor Juhos <juhosg@openwrt.org> git-svn-id: svn://svn.openwrt.org/openwrt/trunk@35733 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom')
-rw-r--r--target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom69
1 files changed, 69 insertions, 0 deletions
diff --git a/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom b/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
new file mode 100644
index 0000000000..a6f9c918fe
--- /dev/null
+++ b/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
@@ -0,0 +1,69 @@
+#!/bin/sh
+
+FW_FILE="/lib/firmware/$FIRMWARE"
+
+ath9k_eeprom_die() {
+ echo "ath9k eeprom: " "$*" >&2
+ exit 1
+}
+
+ath9k_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local mtd
+
+ . /lib/functions.sh
+
+ mtd=$(find_mtd_chardev $part)
+ [ -n "$mtd" ] || \
+ ath9k_eeprom_die "no mtd device found for partition $part"
+
+ dd if=$mtd bs=$offset skip=1 count=1 2>/dev/null | dd of=$FW_FILE bs=$count count=1 2>/dev/null || \
+ ath9k_eeprom_die "failed to extract from $mtd"
+}
+
+tpl_set_wireless_mac()
+{
+ local offset=$1
+ local mac
+
+ . /lib/functions.sh
+
+ mac=$(mtd_get_mac_binary u-boot 326656)
+ mac=$(macaddr_add $mac $offset)
+
+ macaddr_2bin $mac | dd bs=1 count=6 seek=2 conv=notrunc of=$FW_FILE 2>/dev/null
+}
+
+[ -e $FW_FILE ] && exit 0
+
+. /lib/mpc85xx.sh
+
+board=$(mpc85xx_board_name)
+
+case "$FIRMWARE" in
+"pci_wmac0.eeprom")
+ case $board in
+ tl-wdr4900-v1)
+ ath9k_eeprom_extract "caldata" 4096 2048
+ tpl_set_wireless_mac 0
+ ;;
+ *)
+ ath9k_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+
+"pci_wmac1.eeprom")
+ case $board in
+ tl-wdr4900-v1)
+ ath9k_eeprom_extract "caldata" 20480 2048
+ tpl_set_wireless_mac -1
+ ;;
+ *)
+ ath9k_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac